<?php

ini_set('include_path', '.');

require_once('env-parser.php');
require_once('file-util.php');
require_once('db-util.php');

function configure($config_files, $schema_files, $db_ids, $psa_modify_hash, $db_modify_hash, $settings_modify_hash, $crypt_settings_modify_hash, $settings_enum_modify_hash, $additional_modify_hash)
{
    // -- Creating inital DB --

    import_sql_scripts_to_databases($schema_files, $db_ids, $psa_modify_hash, $db_modify_hash, $settings_modify_hash, $crypt_settings_modify_hash, $settings_enum_modify_hash, $additional_modify_hash);

    // -- Writing config file --

    write_config_files($config_files, $psa_modify_hash, $db_modify_hash, $settings_modify_hash, $crypt_settings_modify_hash, $settings_enum_modify_hash, $additional_modify_hash);

    $admin_htpasswd_file = fetch_env_var("WEB___DIR") . '/admin/.htpasswd';
    $ht_bins = array('htpasswd2', 'htpasswd', '/usr/sbin/htpasswd2', '/usr/sbin/htpasswd');
    $htpasswd_bin = '';

    foreach ($ht_bins as $ht_bin) {
        $cmd;
        $cmd = "".$ht_bin."  -cb  ".$admin_htpasswd_file." ";
        $cmd .= fetch_env_var("SETTINGS_admin_name");
        $cmd .= ' "' . fetch_env_var("SETTINGS_admin_password") .'" ';

        print_stderr("cmd = ".$cmd."\n");
        system($cmd, $ret);
        if ($ret != 0) {
            print_stderr("Unable to create file .htpasswd\n");
            $is_error = 1;
        }
        else{
            $htpasswd_bin = $ht_bin;
        }
    }

    if ($htpasswd_bin == '') {
        print_stderr("Unable to find htpasswd binary");
//        exit(1);
    }    
}

function remove_app($schema_files, $db_ids, $psa_modify_hash, $db_modify_hash, $settings_modify_hash, $crypt_settings_modify_hash, $settings_enum_modify_hash, $additional_modify_hash)
{
    import_sql_scripts_to_databases($schema_files, $db_ids, $psa_modify_hash, $db_modify_hash, $settings_modify_hash, $crypt_settings_modify_hash, $settings_enum_modify_hash, $additional_modify_hash);
}

function import_sql_scripts_to_databases($schema_files, $db_ids, $psa_modify_hash, $db_modify_hash, $settings_modify_hash, $crypt_settings_modify_hash, $settings_enum_modify_hash, $additional_modify_hash)
{
    foreach($db_ids as $db_id){
        if(get_db_type($db_id) != "mysql")
        {
            print "FIXME: database type " . get_db_type($db_id) . " is not supported.\n";
            exit(1);
        }
        foreach($schema_files as $schema_filename => $schema_db_id){
            if($schema_db_id == $db_id){
                mysql_db_connect(get_db_address($db_id),
                                 get_db_login($db_id),
                                 get_db_password($db_id),
                                 get_db_name($db_id));

                $sql = modify_content($schema_filename,
                                      array_merge($psa_modify_hash,
                                            $db_modify_hash,
                                            $settings_modify_hash,
                                            $settings_enum_modify_hash,
					    $crypt_settings_modify_hash,
					    $additional_modify_hash));

                populate_mysql_db($sql);
            }
        }
    }
}

function write_config_files($config_files, $psa_modify_hash, $db_modify_hash, $settings_modify_hash, $crypt_settings_modify_hash, $settings_enum_modify_hash, $additional_modify_hash)
{
    foreach($config_files as $web_id => $arr2){
        foreach($arr2 as $arr){
            $template_file = $arr[0];
            $dest_path = get_web_dir($web_id).'/'.$arr[1];
            modify_file($template_file,
                    $dest_path,
                    array_merge($psa_modify_hash,
                          $db_modify_hash,
                          $settings_modify_hash,
                          $settings_enum_modify_hash,
			  $crypt_settings_modify_hash,
			  $additional_modify_hash));
	}
    }
}

?>